<?
/**
* classe che genera l' istanza da un xml
*
* parserizza i file xml e li mette nella struttura di mosaicox2
* @package MoasInstance
* @author Alessandro Vernassa <a.vernassa@teammosaico.biz>
*
* @version 3.0
*
**/
require_once ($app_path . "libs/class.xml2array.php");
require_once ($app_path . "libs/class.array2xml.php");
class MoasInstance
{
	var $parser;
	var $instance;
	var $structure;
	var $XML;
	var $objpath;
	var $encoding;
	var $prologo;
	var $path;
	/**
	* costruttore
	*
	* @name MoasInstance
	* @param string stringa xml
	**/
	function MoasInstance($XML, $path = ".")
	{
		$this->objpath = $path;
		$this->XML = $XML; /* contiene l'XML lell' istanza */
		$xml2array = new xml2array($XML);
		$this->encoding = $xml2array->getEncoding();
		$this->parser = $xml2array->getResult();
		$this->parser['moasclass']=$this->parser['DefMoasclass'];
		$this->parser['moasclass']['@inherit']=$this->parser['DefMoasclass']['@moasclassname'];
		unset($this->parser['moasclass']['@moasclassname']);
		unset($this->parser['DefMoasclass']);


		$this->prologo = $xml2array->getPrologo();
		$tmp = null;
		$this->getXML();
		
		
		
		$this->MakeInstance();
		$this->path = ".";
		$this->_classlist = null;
		//$this->IncludeObjectsLibs();
		//$this->ExecuteObjectsFunctions();
	}
	/**
	* Ritorna l' xml dell' oggetto
	*
	* @name getXML
	* @author Alessandro Vernassa
	**/
	function getXML($tree = null)
	{
		//$this->MakeInstance();
		if ($tree != null)
		{
			if (!isset ($this->structure[$tree]))
			{
				return null;
			}
			$tmp['DefMoasclass'] = $this->structure[$tree];
			$array2xml = new array2xml($tmp, $this->encoding);
			return $array2xml->getResult();
		}
		else
		{
			$tmp=$this->parser;
			$this->Replacethis($tmp);
			$array2xml = new array2xml($this->parser, $this->encoding);
		}
		$this->XML = $array2xml->getResult();
		return $this->XML;
	}
	/**
	* Ritorna l' xml dell' oggetto senza tag e attributi moas
	*
	* crea una stringa con l'xml dell oggetto
	*
	* @param string $tree punto dell' albero
	* @author Alessandro Vernassa
	**/
	function getXMLClean($tree = null)
	{
		if ($tree != null) //--- recupero solo parte dell' xml
		{
			if (!isset ($this->structure[$tree]))
			{
				return null;
			}
			$tmp=$this->parser;
			$this->Replacethis($tmp);
			$tmp2['moasclass'] = $this->__structure[$tree];
			$array2xml = new array2xml($tmp2, $this->encoding);
			$xhtmlstring = $array2xml->getResult();
			$xhtmlstring = eregi_replace("^<!(.+)>", "", eregi_replace("^<?(.+)\?>", "", $xhtmlstring)); //elimino il prologo
			return $this->cleanmoastags($xhtmlstring);
		}
		else
		{
			$tmp=$this->parser;
			$this->Replacethis($tmp);
			$array2xml = new array2xml($tmp, $this->encoding);
			$xhtmlstring = $array2xml->getResult();
		}
		//--- recupero tutto l'xml
		$hd = substr($xhtmlstring, 0, strpos($xhtmlstring, "?>") + 2);
		$xhtmlstring = eregi_replace("^<?(.+)\?>", "", $xhtmlstring);
		$xhtmlstring = $this->cleanmoastags($xhtmlstring);
		return "$hd\n" . $this->prologo . $xhtmlstring;
	}
	/**
	 * cleanmoastags
	 * elimina i tags moas dall' xml
	 * 
	 * @param string $xhtmlstring
	 */
	function cleanmoastags($xhtmlstring)
	{
		$xhtmlstring = eregi_replace("</moasclass>", "", $xhtmlstring);
		$xhtmlstring = eregi_replace("</DefMoasclass>", "", $xhtmlstring);
		$xhtmlstring = eregi_replace('<DefMoasclass(.[^>]+)>', "", $xhtmlstring);
//		$xhtmlstring = eregi_replace('<DefMoasclass(.[a-z0-9\?\"\'\= \.\/\::]+)>', "", $xhtmlstring);
		$xhtmlstring = eregi_replace('<moasclass(.[^>]+)>', "", $xhtmlstring);
		$xhtmlstring = eregi_replace('moasid=\'([a-z0-9]+)\'', "", $xhtmlstring);
		$xhtmlstring = eregi_replace('moasid="([a-z0-9]+)"', "", $xhtmlstring);
		return $xhtmlstring;
	}
	/**
	* aggiorna l' array $this->instance dal parser
	*
	* genera l' istaza
	* @name MakeInstance
	* @author Alessandro Vernassa
	**/
	function MakeInstance()
	{
		//libero i vecchi valori
		if (is_array($this->instance))
			foreach ($this->instance as $key => $value)
				unset ($this->instance[$key]);
		$this->MakeInstance_rec($this->parser);
		
		
	}
	/**
	* esegue i creators associati all'istanza
	*
	* @author Alessandro Vernassa
	**/
	function ExecuteCreators()
	{
		$this->IncludeObjectsLibs();
	}


	/**
	 * DeclareObjectsLibs
	 * @param object $moasinstance istanza moas
	 * include i files php che si riferiscono all'istanza 
	 * e dichiara le classi
	*/
	function DeclareObjectsLibs()
	{
		if (!isset ($this->parser))
			return;
		$this->DeclareObjectsLibs_rec($this->parser);
		if (!isset ($this->parser['DefMoasclass']['@moasclassname']))
		{
			return;
		}
		$instancename = $this->parser['DefMoasclass']['@moasclassname'];
		if (file_exists("actions/$instancename.php"))
			require_once ("actions/$instancename.php");
	}
	/**
	 * IncludeObjectsLibs_rec
	 * @param object $istance istanza moas
	 * include i files php che si riferiscono all'istanza ricorsivamente
	*/
	function DeclareObjectsLibs_rec($parser)
	{
		$path = $this->path;
		foreach ($parser as $k => $ist)
		{

			if (is_array($ist))
				$this->DeclareObjectsLibs_rec($ist);
			else
			{
				if ($k == '@id')
				{
					$str = strrchr($ist, ":");
					$str = str_replace(":", "", $str);
					if ($str != '')
						$ist = $str;
					if (file_exists("$path/actions/$ist.php"))
					{
						require_once ("$path/actions/$ist.php");
					}
				}

				//istanzio le classi
				if ($k == '@inherit' || $k == '@moasclassname')
				{
					if (file_exists("$path/actions/$ist.php"))
					{
						require_once ("$path/actions/$ist.php");
						if (class_exists($ist))
						{
							$classtoexe = null;
							$currpath = "";
							if (isset ($parser['@moasid']))
								$currpath_= $currpath = $parser['@moasid'];
							if (isset($currpath_) && $currpath_!="")
								$currpath_.=":";
							else
							{
								$currpath_ = "";
							}
							//print('<br>$classtoexe = new ' . $ist . '($this, "'.$currpath_.'") ;');
							eval ('$classtoexe = new ' . $ist . '($this, $currpath_) ;');
							unset($this->_classlist[$currpath]);

							$this->_classlist[$currpath] = &$classtoexe;
						}
					}
				}

			}
		}
	}

	/**
	 * IncludeObjectsLibs
	 * @param object $moasinstance istanza moas
	 * include i files php che si riferiscono all'istanza
	*/
	function IncludeObjectsFunctions()
	{
		if (!isset ($this->parser))
			return;
		$this->IncludeObjectsFunctions_rec($this->parser);
		if (!isset ($this->parser['DefMoasclass']['@moasclassname']))
		{
			return;
		}
		$instancename = $this->parser['DefMoasclass']['@moasclassname'];
		if (file_exists("actions/$instancename.php"))
			require_once ("actions/$instancename.php");
	}
	/**
	 * IncludeObjectsLibs_rec
	 * @param object $istance istanza moas
	 * include i files php che si riferiscono all'istanza ricorsivamente
	*/
	function IncludeObjectsFunctions_rec($parser)
	{
		$path = $this->path;
		foreach ($parser as $k => $ist)
		{
			if (is_array($ist))
				$this->IncludeObjectsFunctions_rec($ist);
			else
			{
				if (file_exists("$path/actions/$ist.php"))
				{
					require_once ("$path/actions/$ist.php");
				}
			}
		}
	}


	/**
	* genera l' istanza ricorsivamente
	*
	* funzione ricorsiva per generare l'array $this->instance
	* @name MakeInstance_rec
	* @author Alessandro Vernassa
	**/
	function MakeInstance_rec(& $xmlarray, $path = "",$_path="")
	{
		$idname = "";
		if (isset ($xmlarray['@name']) && !isset ($xmlarray['@id']))
			$xmlarray['@id'] = & $xmlarray['@name'];
		//unset($xmlarray['@name']);
		//$path_clean=$path;

		if (isset ($xmlarray['@id']) || isset ($xmlarray['@name']))
		{
			//$xmlarray['@name']=&$xmlarray['@id'];
			//$path_clean=$path;
			if ($path != "")
				$path .= ":";
			//trasformo pippo:pluto:paperino in paperino
			$name = $xmlarray['@id'];
			$str = strrchr($name, ":");
			$str = str_replace(":", "", $str);
			if ($str != '')
				$name = $str;
			$path .= $name;
			$xmlarray['@id'] = $path;
			
			

			if (isset ($xmlarray['@value']))
			{
				if (!isset ($this->instance[$xmlarray['@id']]->__value))
				{
					$idname = $xmlarray['@id'];
					$this->instance[$idname]->__value = & $xmlarray['@value'];

					if (isset ($xmlarray['@name']))
					{
						$idname = $xmlarray['@name'];
						$this->instance[$xmlarray['@name']]->__value = & $this->instance[$xmlarray['@id']]->__value;
					}
				}
				else //moasid uguali puntano allo stesso valore
					{

					$xmlarray['@value'] = & $this->instance[$xmlarray['@id']]->__value;
				}

			}
			else
			{
				if (!isset ($xmlarray['@inherit']))
				{
					$idname = $xmlarray['@id'];
					$this->instance[$xmlarray['@id']]->__value = & $xmlarray['#text'];
					if (isset ($xmlarray['@name']))
					{
						$idname = $xmlarray['@name'];
						$this->instance[$xmlarray['@name']]->__value = & $xmlarray['#text'];
					}

				}
			}
		}
		
		foreach ($xmlarray as $key => $element)
		{
			if (is_array($element))
			{

				//splxclass
				if (ereg('^moasclass',$key ))
				{
					$xmlarray[$key]['@moasid'] = $path;
					$_path=$path;
				}

				// memorizzo un puntatore al nodo
				if (isset ($xmlarray['@id']))
					$this->structure[$xmlarray['@id']] = & $xmlarray;

				$this->Makeinstance_rec($xmlarray[$key], $path,$_path);
			}
				
		}
		foreach ($xmlarray as $key => $element)
		{

			//splcxlass
			if (strstr($key, "@"))
			{
				// spostare in getxml
				//$xmlarray[$key] = str_replace('$this', $_path, $xmlarray[$key]);
			}
			if (strstr($key, "@") && (isset ($xmlarray['@id']) || isset ($xmlarray['@name'])))
			{
				$nk = str_replace("@", "", $key);
				$this->instance[$idname]-> $nk = & $xmlarray[$key];
			}
		}
	}
	
	
	function Replacethis (& $xmlarray, $path = "",$_path="")
	{
		$idname = "";
		if (isset ($xmlarray['@name']) && !isset ($xmlarray['@id']))
			$xmlarray['@id'] = & $xmlarray['@name'];

		if (isset ($xmlarray['@id']) || isset ($xmlarray['@name']))
		{
			if ($path != "")
				$path .= ":";
			//trasformo pippo:pluto:paperino in paperino
			$name = $xmlarray['@id'];
			$str = strrchr($name, ":");
			$str = str_replace(":", "", $str);
			if ($str != '')
				$name = $str;
			$path .= $name;
			$xmlarray['@id'] = $path;
			if (isset ($xmlarray['@value']))
			{
			}
			else
			{
				if (!isset ($xmlarray['@inherit']))
				{
					$idname = $xmlarray['@id'];
					if (isset ($xmlarray['@name']))
					{
						$idname = $xmlarray['@name'];
					}

				}
			}
		}
		
		foreach ($xmlarray as $key => $element)
		{
			if (is_array($element))
			{
				if (isset ($xmlarray['@id']))
					$this->__structure[$xmlarray['@id']] = & $xmlarray;

				//splxclass
				if (ereg('^moasclass',$key ) )
				{
					$xmlarray[$key]['@moasid'] = $path;
					$_path=$path;
				}
				$this->Replacethis($xmlarray[$key], $path,$_path);
			}
		}
		
		foreach ($xmlarray as $key => $element)
		{
			//splcxlass
			if (ereg("^@",$key))
			{
				$xmlarray[$key] = str_replace('$this', $_path, $xmlarray[$key]);
			
			}
			if (ereg("^#",$key))
			{
				$xmlarray[$key] = str_replace('$this', $_path, $xmlarray[$key]);
			
			}
			
		}
	}
	
	/**
	* inserisce un oggetto in un'altro
	*
	* @name InsertObject
	    * @param string path dove inserire l'oggetto
	    * @param MoasObject oggetto da inserire
	* @author Alessandro Vernassa
	**/
	function InsertObject($where, $what)
	{
		unset($this->_classlist[$where]);
		
		if (!isset($this->structure[$where]))
		{
			echo "insertobject:$where not found";
			return;
		}
		$old = $this->structure[$where];
		$this->structure[$where] = $what->parser;
		//copio gli attributi
		if (is_array($old))
			foreach ($old as $key => $value)
			{
				if (strstr($key, "@"))
					$this->structure[$where][$key] = $value;
			}
		$this->MakeInstance();
		$this->IncludeObjectsFunctions_rec($this->structure[$where]);
		$this->DeclareObjectsLibs_rec($this->structure[$where]);
	}
	/**
	* aggiunge un oggetto in un altro
	*
	* @name AddObject
	    * @param string path dove inserire l'oggetto
	    * @param MoasObject oggetto da inserire
	* @author Alessandro Vernassa
	**/
	function AddObject($where, $what)
	{
		$tmp = & $this->structure[$where];
		foreach ($tmp as $key => $value)
		{
			if (is_array($tmp[$key]))
			{
				array_push($tmp[$key], $what->parser);
				break;
			}
		}
		$this->MakeInstance();
	}
}


/**
 * MoasActions
 * inserire le funzioni comuni per tutte le actions
 * 
 * 
 * 
 * 
 */

class MoasActions
{
	var $path;
	var $instance;
	var $parser;
	function MoasActions (&$instance,$path)
	{
		$this->path=$path;
		$this->instance=&$instance->instance;
		$this->parser=&$instance;
		//echo "MoasActions";
	}
}
?>