<?php
/**
*
* @package array2xml
*/

// compatibilit funzioni xmldom tra php4 e php5

if (version_compare(PHP_VERSION,'5','>='))
	require_once('domxml-php4-to-php5.php');


/**
 * xml_fix
 * converte la stringa xml per poter essere gestita dalle dom
 *
 * @param string xml dell' oggetto
 * @return xml tradotto
 *
**/
function xml_fix($xml)
{

	$xml=ereg_replace("xmlns=\"","__xmlns=\"",$xml); //xmlns viene perso negli attributi
	$xml=ereg_replace("xmlns='","__xmlns='",$xml);   //quindi lo rinomino per non perderlo
	//trasformo i tag inline .....
	//<pippo>ciao <b>bello</b> !!!  </pippo>
	//<pluto><moastmp>ciao </moastmp><b>bello</b><moastmp> !!!   </moastmp></pippo>	

	return $xml;
}

class	xml2array
{
	/**
	*	constructor
	*/
	function xml2array( $xml )
	{
		$xml=xml_fix($xml);
		$this->xml_string=$xml;


		// check for string, open in dom
		if ( is_string($xml) )
		{
			$xml = domxml_open_mem( $xml );
			$this->root_element = $xml->document_element();
		}



		// check for dom-creation,
		if ( is_object( $xml ) && $xml->node_type() == XML_DOCUMENT_NODE )
		{
			$this->root_element = $xml->document_element();
			$this->xml_string = $xml->dump_mem(true,$this->getEncoding());
			return true;
		}

		if ( is_object( $xml ) && $xml->node_type() == XML_ELEMENT_NODE )
		{
			$this->root_element = $xml;
			return true;
		}

		return false;
	}

	/**
	*	recursive function to walk through dom and create array
	*/
	function _recNode2Array( $domnode )
	{
		//dprint_r($domnode->attributes());
		static $gi=0;
		//$gi=0;
		$result=null;
		if ( $domnode->node_type() == XML_ELEMENT_NODE )
		{

			$childs = $domnode->child_nodes();
			foreach($childs as $child)
			{
				if ($child->node_type() == XML_ELEMENT_NODE)
				{
					$subnode = false;
					$prefix = ( $child->prefix() ) ? $child->prefix().':' : '';

					// try to check for multisubnodes
					foreach ($childs as $testnode)
					  if ( is_object($testnode) )
						if ($child->node_name() == $testnode->node_name() && $child != $testnode)
							$subnode = true;

						$result[ $prefix.$child->node_name()."^$gi" ]	= $this->_recNode2Array($child);
						$gi++;
				}
			}

			if (  !is_array($result) )
			{
				// correct encoding from utf-8 to locale
				// NEEDS to be updated to correct in both ways!
				$enc='UTF-8';
				if ($this->getEncoding()!="")
				{
					$enc=$this->getEncoding();
				}

				$result['#text']	=	@html_entity_decode(htmlentities($domnode->get_content(), ENT_QUOTES, 'UTF-8'), ENT_QUOTES,$enc);
			}


			//scansiono tutti gli attributi
			$objectpath="objects/";
			if ( $domnode->has_attributes() )
				foreach ( $domnode->attributes() as $attrib )
				{
					if ($attrib->name() == "moasobjectlocation")
					{
						$prefix = ( $attrib->prefix() ) ? $attrib->prefix().':' : '';
						$objectpath = $attrib->value();
					}
				}




			if ( $domnode->has_attributes() )
				foreach ( $domnode->attributes() as $attrib )
				{
					if ($attrib->name() == "ext")
					{
						//eredito le altre classi
						$prefix = ( $attrib->prefix() ) ? $attrib->prefix().':' : '';
						$result["@".$prefix."inherit"]	=	$attrib->value();



						if (($xml=file_get_contents("$objectpath".$attrib->value().".xml"))===false)
						{
							$xml = "<DefMoasclass moasclassname='".$attrib->value()."'><pre>ERROR: MoasObject \"".$attrib->value()."\" not found</pre></DefMoasclass>";
						}

						
						//prendo l' xml da ereditare e lo converto in array
						$tmp = new  xml2array($xml);
						$xmltmp=$tmp->getResult();

						if (!isset($xmltmp['DefMoasclass']))
						{
							die ("Error : DefMoasclass not found in xml ext:".$attrib->value());
						}
						else
						{
							
							$tmp=$xmltmp['DefMoasclass'];
							$result= $this->mergeXML ($result,$tmp);
						}
					}
					else
					{
						$prefix = ( $attrib->prefix() ) ? $attrib->prefix().':' : '';
						$result["@".$prefix.$attrib->name()]	=	$attrib->value();
					}
				}
			return $result;
		}
	}

	/**
	*	caller func to get an array out of dom
	*/
	function getResult()
	{
		if ( $resultDomNode = $this->root_element )
		{
			$array_result[ $resultDomNode->tagname() ] = $this->_recNode2Array( $resultDomNode );
			return $array_result;
		} else
			return false;
	}

	function getEncoding()
	{
		$result=array();
		$matches=null;
		preg_match("~\<\?xml.*encoding=[\"\'](.*)[\"\'].*\?\>~i",$this->xml_string,$matches);
		return isset($matches[1])?$matches[1]:"";
	}

	function getPrologo()
	{

		$result=array();
		$matches=null;
		preg_match("~\<!(.*)\>~i",$this->xml_string,$matches);
		//dprint_r($matches);
		//die();
		return isset($matches[1])?"<!".$matches[1].">":"";
	}

	function getNamespaces()
	{
		$result=array();
		$matches=null;
		preg_match_all("~[[:space:]]xmlns:([[:alnum:]]*)=[\"\'](.*?)[\"\']~i",$this->xml_string,$matches,PREG_SET_ORDER);
		foreach( $matches as $match )
			$result[ $match[1] ] = $match[2];
		return $result;
	}


	function mergeXML($specifico,$generico)
	{
		

		//dprint_r($generico);
		//dprint_r($specifico);
		//dprint_r("<hr>");

		if(!isset($generico['@id']) && !isset($generico['@moasclassname']))
			return false;
		
		
		//se l' id  diverso
		if (isset($specifico['@id']) && isset($generico['@id']) && $generico['@id'] !=$specifico ['@id'])
		{
			//echo "l'id  diverso";
				return false;
		}
		//se esiste l' id solo per il padre
		if (isset($specifico['@id'])&&!isset($generico['@id']) && !isset($generico['@moasclassname']))
		{
			//echo "l'id solo per il padre";
			return false;
		}

		//se esiste l' id solo per il figlio
		if (!isset($specifico['@id']) && isset($generico['@id']) && !isset($generico['@moasclassname']))
		{
			//echo "l'id solo per il figlio";
			return false;
		}
		
		unset($generico['@moasclassname']);
		
		$res=&$generico;

		foreach ($specifico as $key=>$value)
		{
			//echo "<br>$key=$value";
			if (is_array($specifico[$key]))
			{
				$tmp=false;
				foreach($generico as $k=>$v)
				{
					$tmp=$this->mergeXML($value,$v);
					if($tmp)
					{
						$generico[$k]=$tmp;
						break;
					}
				}
					
				if(!$tmp)
				{
					$generico[$key]=$specifico[$key];
				}

			}
			else
			{
				$generico[$key]=$specifico[$key];
			}	
		}
		return $res;
	
	}




}
?>